#include <iostream>
#include <iomanip>
#include <vector>
#include "../range.hpp"

// everything belongs to range is in Range namespace
using namespace std;
using namespace Range;

int main()
{
    // [0, 10, 20, 30, 40, 50, 60, 70, 80, 90]
    range r(0, 100, 10);
    // range interpolates with STL-containers very well.
    // in fact it is an STL-like container!

    // range::value_type: is simply "int"!
    vector<int> numbers( r.begin(), r.end() ),
                reversed_numbers( r.rbegin(), r.rend() );

    std::cout
        << std::setw(10) << "index"
        << std::setw(20) << "numbers"
        << std::setw(20) << "reversed_numbers"
        << std::endl;
    for(std::size_t i = 0; i < numbers.size(); ++i)
    {
        std::cout
        << std::setw(10) << i
        << std::setw(20) << numbers[i]
        << std::setw(20) << reversed_numbers[i]
        << std::endl;
    }

}